from mpi4py import MPI

class MyClass:

    def __init__(self):
        self.my_str = 'Initialized'

    def print_state(self):
        print(self.my_str)

    def change_state(self, new_str):
        self.my_str = new_str

comm = MPI.COMM_WORLD
size = comm.Get_size()
rank = comm.Get_rank()

if rank == 0:
    my_obj = MyClass()
    comm.send(my_obj,dest=1,tag=1)

if rank == 1:
    obj = comm.recv(source=0,tag=1)
    obj.print_state()
    obj.change_state('I have changed the state of the object')
    comm.send(obj,dest=0,tag=1)

if rank == 0:
    my_changed_obj = comm.recv(source=1,tag=1)
    my_changed_obj.print_state()
